Name:          unitils
Version:       3.4.3
Release:       1%{?dist}
Summary:       Java library aimed at making unit and integration testing easy and maintainable
License:       ASL 2.0
URL:           http://www.unitils.org/
# svn export http://svn.code.sf.net/p/unitils/code/tags/releases/unitils-3.4.3
# find unitils-3.4.3 -name '*.bat' -print -delete 
# find unitils-3.4.3 -name '*.class' -print -delete
# find unitils-3.4.3 -name '*.jar' -print -delete
# rm -rf unitils-3.4.3/lib/*
# rm -rf unitils-3.4.3/unitils-test/test-output/*
# tar cJf unitils-3.4.3.tar.xz unitils-3.4.3
Source0:       %{name}-%{version}.tar.xz

Patch0:        unitils-3.4.3-port-to-easymock3.4.patch

BuildRequires: maven-local
BuildRequires: mvn(cglib:cglib)
BuildRequires: mvn(commons-collections:commons-collections)
BuildRequires: mvn(commons-dbcp:commons-dbcp)
BuildRequires: mvn(commons-lang:commons-lang)
BuildRequires: mvn(commons-logging:commons-logging)
BuildRequires: mvn(javax.persistence:persistence-api)
BuildRequires: mvn(junit:junit)
BuildRequires: mvn(org.apache.commons:commons-ognl)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-jta_1.1_spec)
BuildRequires: mvn(org.dbunit:dbunit)
BuildRequires: mvn(org.easymock:easymock)
BuildRequires: mvn(org.hibernate:hibernate-core:3)
BuildRequires: mvn(org.hibernate:hibernate-entitymanager:3)
BuildRequires: mvn(org.slf4j:slf4j-api)
BuildRequires: mvn(org.slf4j:slf4j-nop)
BuildRequires: mvn(org.sonatype.oss:oss-parent:pom:)
BuildRequires: mvn(org.springframework:spring-beans)
BuildRequires: mvn(org.springframework:spring-context)
BuildRequires: mvn(org.springframework:spring-core)
BuildRequires: mvn(org.springframework:spring-jdbc)
BuildRequires: mvn(org.springframework:spring-test)
BuildRequires: mvn(org.springframework:spring-tx)
BuildRequires: mvn(org.testng:testng::jdk15:)
BuildRequires: mvn(xmlunit:xmlunit)

BuildArch:     noarch

%description
Unitils provides utilities to further simplify unit-testing with JUnit, DBUnit,
EasyMock, Hibernate and Spring. The goal is to make unit-testing easy and
maintainable by offering utilities such as automatic DB-schema maintenance and
equality assertion through reflection.

%package core
Summary:       Unitils core module

%description core
Unitils core module.

%package database
Summary:       Unitils database module

%description database
Unitils database module.

%package dbmaintainer
Summary:       Unitils DbMaintainer module

%description dbmaintainer
Unitils DbMaintainer module.

%package dbunit
Summary:       Unitils DbUnit module

%description dbunit
Support for testing with databases and loading of DbUnit data sets
 * Simplify test database connection setup
 * Support for setting up a separate schema/database per developer
 * Transactional testing
 * Easy loading of data sets
 * Multi-schema data sets
 * Expected data set assertions

%package easymock
Summary:       Unitils EasyMock module

%description easymock
Helps you set up tests that use EasyMock as a mocking framework
 * Simplify EasyMock mock object creation
 * EasyMock argument matching using reflection equality

%package inject
Summary:       Unitils inject module

%description inject
Easily inject test artifacts into classes and instances
 * Inject values by type and name
 * Inject into static fields, e.g. singletons, and automatically
   reset the old value after the test.

%package io
Summary:       Unitils IO module

%description io
Support for performing IO in tests
 * Creating temporary files and directories
 * Loading the contents of files into objects

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%package mock
Summary:       Unitils Mock module

%description mock
Makes mocking easy and maintainable
 * Simple syntax for defining and asserting invoked behavior
 * Gives you the best possible feedback so you can easily
   find out why a test is failing
 * Argument matchers, partial mocking, stubbing behavior,
   dummy objects...

%package orm
Summary:       Unitils ORM module

%description orm
This package provide JPA support, Hibernate
support, TopLink support.

%package spring
Summary:       Unitils Spring module

%description spring
Support for testing when your project uses Spring
 * ApplicationContext configuration and easy
   injection of spring managed beans into a unit test
 * Support for using a Spring-configured
   Hibernate SessionFactory in unit tests.

%package testng
Summary:       Unitils TestNG module

%description testng
This package provide TestNG support.

%prep
%setup -q -n %{name}-%{version}
%patch0 -p1

# Uselees tasks
%pom_remove_plugin -r :maven-assembly-plugin
%pom_remove_plugin -r :maven-gpg-plugin
%pom_remove_plugin -r :maven-release-plugin
%pom_remove_plugin -r :maven-shade-plugin
%pom_remove_plugin -r :maven-source-plugin

%pom_change_dep -r ognl:ognl org.apache.commons:commons-ognl:3.0.2
find ./%{name}-core -name "*.java" -exec sed -i "s/import ognl/import org.apache.commons.ognl/g" {} +
find ./%{name}-inject -name "*.java" -exec sed -i "s/import ognl/import org.apache.commons.ognl/g" {} +

%pom_change_dep -r org.hibernate:hibernate org.hibernate:hibernate-core:3
%pom_change_dep -r :hibernate-entitymanager ::3

%pom_change_dep -r log4j: ::1.2.17
%pom_change_dep -r hsqldb: ::1

%pom_remove_dep -r :easymockclassextension
#rm unitils-test/src/test/java/org/unitils/database/DatabaseModuleTransactionalTestBase.java \
# unitils-test/src/test/java/org/unitils/core/junit/BeforeTestSetUpStatementTest.java \
# unitils-test/src/test/java/org/unitils/core/junit/AfterTestTearDownStatementTest.java \
# unitils-test/src/test/java/org/unitils/easymock/util/LenientMocksControlTest.java \
# unitils-test/src/test/java/org/unitils/easymock/EasyMockModuleTest.java \
# unitils-test/src/test/java/org/unitils/core/junit/BeforeTestMethodStatementTest.java \
# unitils-test/src/test/java/org/unitils/database/DatabaseModuleTransactionManagerTest.java

# concurrent:concurrent:1.3.4
%pom_remove_dep -r :concurrent

# NoClassDefFoundError: Could not initialize class net.sf.cglib.proxy.Enhancer
#%% pom_add_dep cglib:cglib::test unitils-test

# asm:asm-attrs:2.2.3 org.objectweb.asm.tree.analysis.AnalyzerException: Error at instruction 0: Illegal opcode -1
%pom_disable_module unitils-test

# Convert from dos to unix line ending
for file in RELEASE.txt; do
 sed -i.orig 's|\r||g' $file
 touch -r $file.orig $file
 rm $file.orig
done

%build

%mvn_build -s

%install
%mvn_install

%files -f .mfiles-%{name}
%doc RELEASE.txt
%license LICENSE.txt NOTICE.txt

%files core -f .mfiles-%{name}-core
%license LICENSE.txt NOTICE.txt

%files database -f .mfiles-%{name}-database
%files dbmaintainer -f .mfiles-%{name}-dbmaintainer
%files dbunit -f .mfiles-%{name}-dbunit
%files easymock -f .mfiles-%{name}-easymock
%files inject -f .mfiles-%{name}-inject
%files io -f .mfiles-%{name}-io

%files javadoc -f .mfiles-javadoc
%license LICENSE.txt NOTICE.txt

%files mock -f .mfiles-%{name}-mock
%files orm -f .mfiles-%{name}-orm
%files spring -f .mfiles-%{name}-spring
%files testng -f .mfiles-%{name}-testng

%changelog
* Thu Nov 24 2016 gil cattaneo <puntogil@libero.it> 3.4.3-1
- initial rpm

